/*
 *    Copyright (C) 2007 T.Teranishi
 */
#include "stdafx.h"

#include <GL/gl.h>
#include <GL/glu.h>

#include "win32ogl.h"

#include <math.h>

// g@\
typedef BOOL (WINAPI * PFNWGLSWAPINTERVALEXTPROC) (int interval);

PFNWGLSWAPINTERVALEXTPROC wglSwapIntervalEXT = NULL;

// 
void Initialize(unsigned int width, unsigned int height)
{
	Resize(width, height);

	glClearColor(0.8f, 0.8f, 0.8f, 0.0f);
}

// `
void DrawScene(HWND hWnd, unsigned int width, unsigned int height, time_t elapsedTime)
{
	float angle;

	// 5b360x]
	angle = 360.0f * (float)elapsedTime / 1000.0f / 5.0f;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	/* yellow */
	glColor4f(1.0f, 1.0f, 0.0f, 1.0f);

	glPushMatrix();
		glRotatef(angle, 0.0f, 0.0f, 1.0f);

		glBegin(GL_TRIANGLES);
		glVertex3f(-0.6f, -(float)sqrt(3.0) * 0.2f, 0.0f);
		glVertex3f( 0.6f, -(float)sqrt(3.0) * 0.2f, 0.0f);
		glVertex3f( 0.0f,  (float)sqrt(3.0) * 0.4f, 0.0f);
		glEnd();
	glPopMatrix();

	// Xbvobt@
	SwapBuffers(wglGetCurrentDC());
}

void Resize(unsigned int width, unsigned int height)
{
	double aspect = (double)width / (double)height;

	glViewport(0, 0, width, height);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-aspect, aspect, -1.0f, 1.0f, -1.0f, 1.0f);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

// AChO
void Idle(HWND hWnd)
{
	// ĕ`
	InvalidateRect(hWnd, NULL, FALSE);
}

// _OReLXg̍쐬
HGLRC WGLCreate(HWND hWnd)
{
	PIXELFORMATDESCRIPTOR pfd = { 
		sizeof(PIXELFORMATDESCRIPTOR),   // size of this pfd 
		1,                     // version number 
		PFD_DRAW_TO_WINDOW |   // support window 
		PFD_SUPPORT_OPENGL |   // support OpenGL 
		PFD_DOUBLEBUFFER,      // double buffered 
		PFD_TYPE_RGBA,         // RGBA type 
		24,                    // 24-bit color depth 
		0, 0, 0, 0, 0, 0,      // color bits ignored 
		0,                     // no alpha buffer 
		0,                     // shift bit ignored 
		0,                     // no accumulation buffer 
		0, 0, 0, 0,            // accum bits ignored 
		24,                    // 24-bit z-buffer 
		0,                     // no stencil buffer 
		0,                     // no auxiliary buffer 
		PFD_MAIN_PLANE,        // main layer 
		0,                     // reserved 
		0, 0, 0                // layer masks ignored 
	}; 
	HDC  hdc = GetDC(hWnd); 
	int  iPixelFormat; 
	HGLRC hRC;

	iPixelFormat = ChoosePixelFormat(hdc, &pfd); 
	SetPixelFormat(hdc, iPixelFormat, &pfd);	
	hRC = wglCreateContext(hdc);

	wglMakeCurrent(hdc, hRC);

	// g@\
	wglSwapIntervalEXT = (PFNWGLSWAPINTERVALEXTPROC)wglGetProcAddress("wglSwapIntervalEXT");

	if (wglSwapIntervalEXT) {
		wglSwapIntervalEXT(1);
	}

	wglMakeCurrent(NULL, NULL);

	ReleaseDC(hWnd, hdc);

	return hRC;
}

// _OReLXg̍폜ȂI
void WGLDelete(HGLRC hRC)
{
	wglDeleteContext(hRC);
}